(* This is the source calculus of the sample client. It is a core ML. *)

type program = definition list

and definition =
  | TyDef of tycon * tyvar list * tydefinition
  | ValDef of tevar * term

and tydefinition =
  | Abbrev of typ

and tycon = TyConstructor.id

and tevar = string

and term =
  | Var of tevar
  | Abs of tevar * typ option * term
  | App of term * term
  | Let of tevar * typ option * term * term
  | Pair of term * term
  | Proj of int * term
  | Lit of literal
  | Annot of term * typ
  | NTyVar of tyvar * term

and literal =
  | LInt of int

and typ =
  | TyVar of tyvar
  (*| TyForall of tyvar list * typ*)
  | TyMu of tyvar * typ
  | TyCon of tycon * typ list

and tyvar = int
